<template>
  <div
    class="button-wrapper flex justify-center items-center font-medium"
    :class="[heightClass, colorClass, disabled ? 'button-wrapper_disabled' : 'cursor-pointer']"
    @click="handleClick"
    @mousedown.prevent
  >
    <slot />
  </div>
</template>

<script>
export default {
  name: 'UiButton',

  props: {
    buttonHeight: {
      type: String,
      default: 'md',
    },

    colorType: {
      type: String,
      default: 'primary',
    },

    disabled: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    heightClass() {
      if (this.$props.buttonHeight === 'lg') return 'h-24';
      if (this.$props.buttonHeight === 'md') return 'h-16';
      if (this.$props.buttonHeight === 'sm') return 'h-12';
      return '';
    },

    colorClass() {
      if (this.$props.disabled) return 'bg-btnlprimdis dark:bg-btndprimdis text-txtltert dark:text-txtdtert';
      if (this.$props.colorType === 'secondary')
        return 'bg-btnlsec dark:bg-btndsec text-txtlsec dark:text-txtdsec hover:shadow-seclhov dark:hover:shadow-secdhov active:shadow-seclact dark:active:shadow-secdact';
      if (this.$props.colorType === 'outline')
        return 'bg-transparent text-txtlsec dark:text-txtdsec shadow-outlhov dark:shadow-outdhov hover:bg-btnlouthov dark:hover:bg-btndouthov active:bg-btnlouthov dark:active:bg-btndouthov hover:shadow-outlhov dark:hover:shadow-outdhov active:shadow-outlact dark:active:shadow-outdact';
      if (this.$props.colorType === 'transparent')
        return 'bg-transparent text-txtlsec dark:text-txtdsec hover:bg-btnltsphov dark:hover:bg-btndtsphov active:bg-btnltsphov dark:active:bg-btndtsphov hover:shadow-tsplhov dark:hover:shadow-tspdhov active:shadow-tsplact dark:active:shadow-tspdact';
      if (this.$props.colorType === 'primary')
        return 'button-wrapper_primary bg-btndprim hover:bg-btndprimhov text-txtdprim hover:shadow-primlhov active:shadow-primlact';
      return '';
    },
  },

  methods: {
    handleClick() {
      if (this.disabled) return;
      this.$emit('click');
    },
  },
};
</script>

<style lang="scss">
.button-wrapper {
  transition: transform 75ms, box-shadow 150ms;
  &:active {
    transform: scale(0.97);
  }

  &_disabled {
    &:active {
      transform: scale(1);
    }
    & > img {
      filter: invert(92%) sepia(6%) saturate(694%) hue-rotate(186deg) brightness(85%) contrast(87%);
    }
  }

  &_primary {
    & div {
      @apply bg-btndprim;
    }

    &:hover div {
      @apply bg-btndprimhov;
    }
  }
}

.dark {
  .button-wrapper {
    &_disabled {
      & > img {
        filter: invert(22%) sepia(17%) saturate(583%) hue-rotate(175deg) brightness(91%) contrast(86%);
      }
    }
  }
}
</style>
